diff --git a/lustre/obdclass/linux/linux-sysctl.c b/lustre/obdclass/linux/linux-sysctl.c
index db6edd8..61af63c 100644
--- a/lustre/obdclass/linux/linux-sysctl.c
+++ b/lustre/obdclass/linux/linux-sysctl.c
@@ -313,7 +313,9 @@ int LL_PROC_PROTO(proc_at_history)
 #ifdef CONFIG_SYSCTL
 static cfs_sysctl_table_t obd_table[] = {
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_TIMEOUT,
+#endif
                 .procname = "timeout",
                 .data     = &obd_timeout,
                 .maxlen   = sizeof(int),
@@ -321,7 +323,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_set_timeout
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_DEBUG_PEER_ON_TIMEOUT,
+#endif
                 .procname = "debug_peer_on_timeout",
                 .data     = &obd_debug_peer_on_timeout,
                 .maxlen   = sizeof(int),
@@ -329,7 +333,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_dointvec
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_DUMP_ON_TIMEOUT,
+#endif
                 .procname = "dump_on_timeout",
                 .data     = &obd_dump_on_timeout,
                 .maxlen   = sizeof(int),
@@ -337,7 +343,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_dointvec
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_DUMP_ON_EVICTION,
+#endif
                 .procname = "dump_on_eviction",
                 .data     = &obd_dump_on_eviction,
                 .maxlen   = sizeof(int),
@@ -345,7 +353,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_dointvec
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_MEMUSED,
+#endif
                 .procname = "memused",
                 .data     = NULL,
                 .maxlen   = 0,
@@ -353,7 +363,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_memory_alloc
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_PAGESUSED,
+#endif
                 .procname = "pagesused",
                 .data     = NULL,
                 .maxlen   = 0,
@@ -361,7 +373,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_pages_alloc
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_MAXMEMUSED,
+#endif
                 .procname = "memused_max",
                 .data     = NULL,
                 .maxlen   = 0,
@@ -369,7 +383,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_mem_max
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_MAXPAGESUSED,
+#endif
                 .procname = "pagesused_max",
                 .data     = NULL,
                 .maxlen   = 0,
@@ -377,7 +393,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_pages_max
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_LDLM_TIMEOUT,
+#endif
                 .procname = "ldlm_timeout",
                 .data     = &ldlm_timeout,
                 .maxlen   = sizeof(int),
@@ -386,7 +404,9 @@ static cfs_sysctl_table_t obd_table[] = {
         },
 #ifdef RANDOM_FAIL_ALLOC
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_ALLOC_FAIL_RATE,
+#endif
                 .procname = "alloc_fail_rate",
                 .data     = &obd_alloc_fail_rate,
                 .maxlen   = sizeof(int),
@@ -395,7 +415,9 @@ static cfs_sysctl_table_t obd_table[] = {
         },
 #endif
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_MAX_DIRTY_PAGES,
+#endif
                 .procname = "max_dirty_mb",
                 .data     = &obd_max_dirty_pages,
                 .maxlen   = sizeof(int),
@@ -403,7 +425,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_max_dirty_pages_in_mb
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_AT_MIN,
+#endif
                 .procname = "at_min",
                 .data     = &at_min,
                 .maxlen   = sizeof(int),
@@ -411,7 +435,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_at_min
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_AT_MAX,
+#endif
                 .procname = "at_max",
                 .data     = &at_max,
                 .maxlen   = sizeof(int),
@@ -419,7 +445,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_at_max
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_AT_EXTRA,
+#endif
                 .procname = "at_extra",
                 .data     = &at_extra,
                 .maxlen   = sizeof(int),
@@ -427,7 +455,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_at_extra
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_AT_EARLY_MARGIN,
+#endif
                 .procname = "at_early_margin",
                 .data     = &at_early_margin,
                 .maxlen   = sizeof(int),
@@ -435,7 +465,9 @@ static cfs_sysctl_table_t obd_table[] = {
                 .proc_handler = &proc_at_early_margin
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_AT_HISTORY,
+#endif
                 .procname = "at_history",
                 .data     = &at_history,
                 .maxlen   = sizeof(int),
@@ -447,7 +479,9 @@ static cfs_sysctl_table_t obd_table[] = {
 
 static cfs_sysctl_table_t parent_table[] = {
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = OBD_SYSCTL,
+#endif
                 .procname = "lustre",
                 .data     = NULL,
                 .maxlen   = 0,
diff --git a/lustre/obdclass/obd_mount.c b/lustre/obdclass/obd_mount.c
index e92d1c2..40d5ea1 100644
--- a/lustre/obdclass/obd_mount.c
+++ b/lustre/obdclass/obd_mount.c
@@ -80,6 +80,22 @@ static struct lustre_mount_info *server_find_mount(const char *name)
         RETURN(NULL);
 }
 
+static unsigned int mnt_get_count(struct vfsmount *mnt)
+{
+#ifdef CONFIG_SMP
+        unsigned int count = 0;
+        int cpu;
+
+        for_each_possible_cpu(cpu) {
+                count += per_cpu_ptr(mnt->mnt_pcp, cpu)->mnt_count;
+        }
+
+        return count;
+#else
+        return mnt->mnt_count;
+#endif
+}
+
 /* we must register an obd for a mount before we call the setup routine.
    *_setup will call lustre_get_mount to get the mnt struct
    by obd_name, since we can't pass the pointer to setup. */
@@ -120,7 +136,7 @@ static int server_register_mount(const char *name, struct super_block *sb,
         cfs_up(&lustre_mount_info_lock);
 
         CDEBUG(D_MOUNT, "reg_mnt %p from %s, vfscount=%d\n",
-               lmi->lmi_mnt, name, cfs_atomic_read(&lmi->lmi_mnt->mnt_count));
+               lmi->lmi_mnt, name, mnt_get_count(lmi->lmi_mnt));
 
         RETURN(0);
 }
@@ -140,7 +156,7 @@ static int server_deregister_mount(const char *name)
         }
 
         CDEBUG(D_MOUNT, "dereg_mnt %p from %s, vfscount=%d\n",
-               lmi->lmi_mnt, name, cfs_atomic_read(&lmi->lmi_mnt->mnt_count));
+               lmi->lmi_mnt, name, mnt_get_count(lmi->lmi_mnt));
 
         OBD_FREE(lmi->lmi_name, strlen(lmi->lmi_name) + 1);
         cfs_list_del(&lmi->lmi_list_chain);
@@ -172,7 +188,7 @@ struct lustre_mount_info *server_get_mount(const char *name)
 
         CDEBUG(D_MOUNT, "get_mnt %p from %s, refs=%d, vfscount=%d\n",
                lmi->lmi_mnt, name, cfs_atomic_read(&lsi->lsi_mounts),
-               cfs_atomic_read(&lmi->lmi_mnt->mnt_count));
+               mnt_get_count(lmi->lmi_mnt));
 
         RETURN(lmi);
 }
@@ -196,6 +212,8 @@ struct lustre_mount_info *server_get_mount_2(const char *name)
         RETURN(lmi);
 }
 
+#define kernel_locked()         (current->lock_depth >= 0)
+
 static void unlock_mntput(struct vfsmount *mnt)
 {
         if (kernel_locked()) {
@@ -214,7 +232,7 @@ int server_put_mount(const char *name, struct vfsmount *mnt)
 {
         struct lustre_mount_info *lmi;
         struct lustre_sb_info *lsi;
-        int count = atomic_read(&mnt->mnt_count) - 1;
+        int count = mnt_get_count(mnt) - 1;
         ENTRY;
 
         /* This might be the last one, can't deref after this */
@@ -1422,25 +1440,25 @@ static void server_wait_finished(struct vfsmount *mnt)
 
        cfs_waitq_init(&waitq);
 
-       while (atomic_read(&mnt->mnt_count) > 1) {
+       while (mnt_get_count(mnt) > 1) {
                if (waited && (waited % 30 == 0))
                        LCONSOLE_WARN("Mount still busy with %d refs after "
                                       "%d secs.\n",
-                                      atomic_read(&mnt->mnt_count),
+                                      mnt_get_count(mnt),
                                       waited);
                /* Cannot use l_event_wait() for an interruptible sleep. */
                waited += 3;
                blocked = cfs_block_sigsinv(sigmask(SIGKILL));
                cfs_waitq_wait_event_interruptible_timeout(
                        waitq,
-                       (atomic_read(&mnt->mnt_count) == 1),
+                       (mnt_get_count(mnt) == 1),
                        cfs_time_seconds(3),
                        rc);
                cfs_block_sigs(blocked);
                if (rc < 0) {
                        LCONSOLE_EMERG("Danger: interrupted umount %s with "
                                       "%d refs!\n", mnt->mnt_devname,
-                                      atomic_read(&mnt->mnt_count));
+                                      mnt_get_count(mnt));
                        break;
                }
 
@@ -1569,6 +1587,8 @@ static void server_umount_begin(struct super_block *sb)
         EXIT;
 }
 
+#define HAVE_STATFS_DENTRY_PARAM 1
+
 #ifndef HAVE_STATFS_DENTRY_PARAM
 static int server_statfs (struct super_block *sb, cfs_kstatfs_t *buf)
 {
diff --git a/lustre/obdfilter/filter.c b/lustre/obdfilter/filter.c
index f05b13b..981f100 100644
--- a/lustre/obdfilter/filter.c
+++ b/lustre/obdfilter/filter.c
@@ -52,7 +52,12 @@
 #define DEBUG_SUBSYSTEM S_FILTER
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/fs.h>
diff --git a/lustre/obdfilter/filter_io.c b/lustre/obdfilter/filter_io.c
index 859e290..d6b763b 100644
--- a/lustre/obdfilter/filter_io.c
+++ b/lustre/obdfilter/filter_io.c
@@ -43,7 +43,12 @@
 #define DEBUG_SUBSYSTEM S_FILTER
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/pagemap.h> // XXX kill me soon
diff --git a/lustre/obdfilter/filter_io_26.c b/lustre/obdfilter/filter_io_26.c
index 806734b..4fe398b 100644
--- a/lustre/obdfilter/filter_io_26.c
+++ b/lustre/obdfilter/filter_io_26.c
@@ -41,7 +41,12 @@
  */
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/pagemap.h> // XXX kill me soon
diff --git a/lustre/obdfilter/filter_log.c b/lustre/obdfilter/filter_log.c
index 7ae5f88..4a8542d 100644
--- a/lustre/obdfilter/filter_log.c
+++ b/lustre/obdfilter/filter_log.c
@@ -43,7 +43,12 @@
 #define DEBUG_SUBSYSTEM S_FILTER
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/version.h>
diff --git a/lustre/obdfilter/filter_lvb.c b/lustre/obdfilter/filter_lvb.c
index 080db86..a650c85 100644
--- a/lustre/obdfilter/filter_lvb.c
+++ b/lustre/obdfilter/filter_lvb.c
@@ -43,7 +43,12 @@
 #define DEBUG_SUBSYSTEM S_FILTER
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/version.h>
diff --git a/lustre/osc/osc_request.c b/lustre/osc/osc_request.c
index a6dd7cc..2a1a9f1 100644
--- a/lustre/osc/osc_request.c
+++ b/lustre/osc/osc_request.c
@@ -2284,10 +2284,8 @@ static struct ptlrpc_request *osc_build_req(const struct lu_env *env,
         struct osc_brw_async_args *aa;
         struct obdo *oa = NULL;
         const struct obd_async_page_ops *ops = NULL;
-        void *caller_data = NULL;
         struct osc_async_page *oap;
         struct osc_async_page *tmp;
-        struct ost_body *body;
         struct cl_req *clerq = NULL;
         enum cl_req_type crt = (cmd & OBD_BRW_WRITE) ? CRT_WRITE : CRT_READ;
         struct ldlm_lock *lock = NULL;
@@ -2314,7 +2312,6 @@ static struct ptlrpc_request *osc_build_req(const struct lu_env *env,
                 struct cl_page *page = osc_oap2cl_page(oap);
                 if (ops == NULL) {
                         ops = oap->oap_caller_ops;
-                        caller_data = oap->oap_caller_data;
 
                         clerq = cl_req_alloc(env, page, crt,
                                              1 /* only 1-object rpcs for
@@ -2363,7 +2360,6 @@ static struct ptlrpc_request *osc_build_req(const struct lu_env *env,
          * later setattr before earlier BRW (as determined by the request xid),
          * the OST will not use BRW timestamps.  Sadly, there is no obvious
          * way to do this in a single call.  bug 10150 */
-        body = req_capsule_client_get(&req->rq_pill, &RMF_OST_BODY);
         cl_req_attr_set(env, clerq, &crattr,
                         OBD_MD_FLMTIME|OBD_MD_FLCTIME|OBD_MD_FLATIME);
 
diff --git a/lustre/ptlrpc/llog_server.c b/lustre/ptlrpc/llog_server.c
index 3929127..e673548 100644
--- a/lustre/ptlrpc/llog_server.c
+++ b/lustre/ptlrpc/llog_server.c
@@ -127,7 +127,6 @@ int llog_origin_handle_destroy(struct ptlrpc_request *req)
         struct lvfs_run_ctxt  saved;
         struct llog_logid    *logid = NULL;
         struct llog_ctxt     *ctxt;
-        __u32                 flags;
         int                   rc;
         ENTRY;
 
@@ -155,7 +154,6 @@ int llog_origin_handle_destroy(struct ptlrpc_request *req)
 
         body = req_capsule_server_get(&req->rq_pill, &RMF_LLOGD_BODY);
         body->lgd_logid = loghandle->lgh_id;
-        flags = body->lgd_llh_flags;
         rc = llog_init_handle(loghandle, LLOG_F_IS_PLAIN, NULL);
         if (rc)
                 GOTO(out_close, rc);
diff --git a/lustre/ptlrpc/sec_config.c b/lustre/ptlrpc/sec_config.c
index 5af3690..1c7c866 100644
--- a/lustre/ptlrpc/sec_config.c
+++ b/lustre/ptlrpc/sec_config.c
@@ -795,14 +795,13 @@ EXPORT_SYMBOL(sptlrpc_conf_log_update_end);
 
 void sptlrpc_conf_log_start(const char *logname)
 {
-        struct sptlrpc_conf *conf;
-        char                 fsname[16];
+        char fsname[16];
 
         if (logname2fsname(logname, fsname, sizeof(fsname)))
                 return;
 
         cfs_mutex_lock(&sptlrpc_conf_lock);
-        conf = sptlrpc_conf_get(fsname, 1);
+        sptlrpc_conf_get(fsname, 1);
         cfs_mutex_unlock(&sptlrpc_conf_lock);
 }
 EXPORT_SYMBOL(sptlrpc_conf_log_start);
diff --git a/lustre/ptlrpc/sec_plain.c b/lustre/ptlrpc/sec_plain.c
index b0b9035..283c489 100644
--- a/lustre/ptlrpc/sec_plain.c
+++ b/lustre/ptlrpc/sec_plain.c
@@ -351,8 +351,8 @@ int plain_cli_unwrap_bulk(struct ptlrpc_cli_ctx *ctx,
                           struct ptlrpc_request *req,
                           struct ptlrpc_bulk_desc *desc)
 {
-        struct ptlrpc_bulk_sec_desc *bsdr, *bsdv;
-        struct plain_bulk_token     *tokenr, *tokenv;
+        struct ptlrpc_bulk_sec_desc *bsdv;
+        struct plain_bulk_token     *tokenv;
         int                          rc;
 #ifdef __KERNEL__
         int                          i, nob;
@@ -362,8 +362,6 @@ int plain_cli_unwrap_bulk(struct ptlrpc_cli_ctx *ctx,
         LASSERT(req->rq_reqbuf->lm_bufcount == PLAIN_PACK_SEGMENTS);
         LASSERT(req->rq_repdata->lm_bufcount == PLAIN_PACK_SEGMENTS);
 
-        bsdr = lustre_msg_buf(req->rq_reqbuf, PLAIN_PACK_BULK_OFF, 0);
-        tokenr = (struct plain_bulk_token *) bsdr->bsd_data;
         bsdv = lustre_msg_buf(req->rq_repdata, PLAIN_PACK_BULK_OFF, 0);
         tokenv = (struct plain_bulk_token *) bsdv->bsd_data;
 
@@ -911,7 +909,7 @@ int plain_svc_unwrap_bulk(struct ptlrpc_request *req,
 {
         struct ptlrpc_reply_state   *rs = req->rq_reply_state;
         struct ptlrpc_bulk_sec_desc *bsdr, *bsdv;
-        struct plain_bulk_token     *tokenr, *tokenv;
+        struct plain_bulk_token     *tokenr;
         int                          rc;
 
         LASSERT(req->rq_bulk_write);
@@ -920,7 +918,6 @@ int plain_svc_unwrap_bulk(struct ptlrpc_request *req,
         bsdr = lustre_msg_buf(req->rq_reqbuf, PLAIN_PACK_BULK_OFF, 0);
         tokenr = (struct plain_bulk_token *) bsdr->bsd_data;
         bsdv = lustre_msg_buf(rs->rs_repbuf, PLAIN_PACK_BULK_OFF, 0);
-        tokenv = (struct plain_bulk_token *) bsdv->bsd_data;
 
         bsdv->bsd_version = 0;
         bsdv->bsd_type = SPTLRPC_BULK_DEFAULT;
@@ -946,14 +943,13 @@ int plain_svc_wrap_bulk(struct ptlrpc_request *req,
 {
         struct ptlrpc_reply_state   *rs = req->rq_reply_state;
         struct ptlrpc_bulk_sec_desc *bsdr, *bsdv;
-        struct plain_bulk_token     *tokenr, *tokenv;
+        struct plain_bulk_token     *tokenv;
         int                          rc;
 
         LASSERT(req->rq_bulk_read);
         LASSERT(req->rq_pack_bulk);
 
         bsdr = lustre_msg_buf(req->rq_reqbuf, PLAIN_PACK_BULK_OFF, 0);
-        tokenr = (struct plain_bulk_token *) bsdr->bsd_data;
         bsdv = lustre_msg_buf(rs->rs_repbuf, PLAIN_PACK_BULK_OFF, 0);
         tokenv = (struct plain_bulk_token *) bsdv->bsd_data;
 
diff --git a/lustre/ptlrpc/service.c b/lustre/ptlrpc/service.c
index 902cdfd..5a26216 100644
--- a/lustre/ptlrpc/service.c
+++ b/lustre/ptlrpc/service.c
@@ -1591,7 +1591,7 @@ ptlrpc_server_handle_request(struct ptlrpc_service *svc,
         struct timeval         work_start;
         struct timeval         work_end;
         long                   timediff;
-        int                    opc, rc;
+        int                    rc;
         int                    fail_opc = 0;
         ENTRY;
 
@@ -1611,7 +1611,6 @@ ptlrpc_server_handle_request(struct ptlrpc_service *svc,
                 RETURN(0);
         }
 
-        opc = lustre_msg_get_opc(request->rq_reqmsg);
         if (OBD_FAIL_CHECK(OBD_FAIL_PTLRPC_HPREQ_NOTIMEOUT))
                 fail_opc = OBD_FAIL_PTLRPC_HPREQ_NOTIMEOUT;
         else if (OBD_FAIL_CHECK(OBD_FAIL_PTLRPC_HPREQ_TIMEOUT))
@@ -1783,13 +1782,11 @@ ptlrpc_handle_rs (struct ptlrpc_reply_state *rs)
 {
         struct ptlrpc_service     *svc = rs->rs_service;
         struct obd_export         *exp;
-        struct obd_device         *obd;
         int                        nlocks;
         int                        been_handled;
         ENTRY;
 
         exp = rs->rs_export;
-        obd = exp->exp_obd;
 
         LASSERT (rs->rs_difficult);
         LASSERT (rs->rs_scheduled);
diff --git a/lustre/ptlrpc/wirehdr.c b/lustre/ptlrpc/wirehdr.c
index 0c39cce..5c4ec35 100644
--- a/lustre/ptlrpc/wirehdr.c
+++ b/lustre/ptlrpc/wirehdr.c
@@ -41,7 +41,12 @@
 
 #ifdef __KERNEL__
 # ifndef AUTOCONF_INCLUDED
-#  include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 # endif
 # ifdef CONFIG_FS_POSIX_ACL
 #  include <linux/fs.h>
diff --git a/lustre/ptlrpc/wiretest.c b/lustre/ptlrpc/wiretest.c
index 452327c..3f7ecae 100644
--- a/lustre/ptlrpc/wiretest.c
+++ b/lustre/ptlrpc/wiretest.c
@@ -41,7 +41,12 @@
 
 #ifdef __KERNEL__
 # ifndef AUTOCONF_INCLUDED
-#  include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 # endif
 # ifdef CONFIG_FS_POSIX_ACL
 #  include <linux/fs.h>
diff --git a/lustre/quota/lproc_quota.c b/lustre/quota/lproc_quota.c
index 828a7c1..df99540 100644
--- a/lustre/quota/lproc_quota.c
+++ b/lustre/quota/lproc_quota.c
@@ -181,12 +181,9 @@ int lprocfs_quota_rd_type(char *page, char **start, off_t off, int count,
         struct obd_device *obd = (struct obd_device *)data;
         char stype[MAX_STYPE_SIZE + 1] = "";
         int oq_type;
-        struct obd_device_target *obt;
 
         LASSERT(obd != NULL);
 
-        obt = &obd->u.obt;
-
         /* Collect the needed information */
         oq_type = obd->u.obt.obt_qctxt.lqc_flags;
 
@@ -291,17 +288,12 @@ int lprocfs_quota_wr_type(struct file *file, const char *buffer,
                           unsigned long count, void *data)
 {
         struct obd_device *obd = (struct obd_device *)data;
-        struct obd_device_target *obt;
-        int type = 0, is_mds;
+        int type = 0;
         unsigned long i;
         char stype[MAX_STYPE_SIZE + 1] = "";
 
         LASSERT(obd != NULL);
 
-        obt = &obd->u.obt;
-
-        is_mds = !strcmp(obd->obd_type->typ_name, LUSTRE_MDS_NAME);
-
         if (count > MAX_STYPE_SIZE)
                 return -EINVAL;
 
diff --git a/lustre/tests/writeme.c b/lustre/tests/writeme.c
index 837552d..e511af4 100644
--- a/lustre/tests/writeme.c
+++ b/lustre/tests/writeme.c
@@ -47,7 +47,7 @@ void usage(char *prog)
 
 int main(int argc, char **argv)
 {
-        int fd, rc;
+        int fd;
 	int do_sync = 0;
         int i = 0;
 	int file_arg = 1;
@@ -73,7 +73,7 @@ int main(int argc, char **argv)
 
         while (1) {
                 sprintf(buf, "write %d\n", i);
-                rc = write(fd, buf, sizeof(buf));
+                write(fd, buf, sizeof(buf));
 		if (do_sync)
 			sync();
                 sleep(1);
diff --git a/lustre/utils/liblustreapi.c b/lustre/utils/liblustreapi.c
index dc989a7..d353111 100644
--- a/lustre/utils/liblustreapi.c
+++ b/lustre/utils/liblustreapi.c
@@ -2438,7 +2438,6 @@ int llapi_target_iterate(int type_num, char **obd_type,void *args,llapi_cb_t cb)
                 char *obd_name = NULL;
                 char *obd_uuid = NULL;
                 char *bufp = buf;
-                struct obd_ioctl_data datal = { 0, };
                 struct obd_statfs osfs_buffer;
 
                 while(bufp[0] == ' ')
@@ -2452,9 +2451,6 @@ int llapi_target_iterate(int type_num, char **obd_type,void *args,llapi_cb_t cb)
 
                 memset(&osfs_buffer, 0, sizeof (osfs_buffer));
 
-                datal.ioc_pbuf1 = (char *)&osfs_buffer;
-                datal.ioc_plen1 = sizeof(osfs_buffer);
-
                 for (i = 0; i < type_num; i++) {
                         if (strcmp(obd_type_name, obd_type[i]) != 0)
                                 continue;
diff --git a/lustre/utils/ll_decode_filter_fid.c b/lustre/utils/ll_decode_filter_fid.c
index ac14f25..a394a4c 100644
--- a/lustre/utils/ll_decode_filter_fid.c
+++ b/lustre/utils/ll_decode_filter_fid.c
@@ -51,12 +51,9 @@
 
 int main(int argc, char *argv[])
 {
-	char *prog;
 	int rc = 0;
 	int i;
 
-	prog = basename(argv[0]);
-
 	for (i = 1; i < argc; i++) {
 		char buf[1024]; /* allow xattr that may be larger */
 		struct filter_fid *ff = (void *)buf;
